@version 2.6
@warnings
@script layouttool
@name Limited Region Tool
startPoint;endPoint;
startPointPix;endPointPix;
renderCameraPos;
leftUpVec;
rightUpVec;
leftDownVec;
rightDownVec;
distMultiplier;
left;right;width;height;
camW;camH;
camResRatio;
screenRatio;
screenCamW;
screenCamH;
borderPixelsW;
borderPixelsH;
global_finalX;
global_finalY;
global_finalW;
global_finalH;
RMB;global_teViewNumber;rmbFunc;
c1;

tooldraw: coa
{
	coa.setColor(0,0,0);
	//~ coa.setPattern("LONGDOT");
	if(renderCamPos == nil)
	{
		renderCamPos = Scene().renderCamera(Scene().currenttime).getWorldPosition(Scene().currenttime);
	}
	if(startPoint && endPoint)
	{
		drawStart = ((startPoint - renderCamPos) / distMultiplier) + renderCamPos;
		drawEnd = ((endPoint - renderCamPos) / distMultiplier) + renderCamPos;
		
		coa.drawLine(drawStart,drawEnd,"ICON");

		coa.drawLine(leftUpVec,rightUpVec,"ICON");
		coa.drawLine(leftUpVec,leftDownVec,"ICON");
		coa.drawLine(leftDownVec,rightDownVec,"ICON");
		coa.drawLine(rightUpVec,rightDownVec,"ICON");
		
		btm = (leftDownVec + rightDownVec) / 2;
		left = (rightUpVec + rightDownVec) / 2;
		coa.setColor(1,1,0);
		coa.drawText(btm,string(integer(global_finalW)));
		coa.drawText(left,string(integer(global_finalH)));
	}
	
	

}
convertToScreenCam: x, y
{
	//~ x = x + borderPixelsW;
	//~ y = y + borderPixelsH;
	fx = ((x / camW) * screenCamW) + borderPixelsW;
	fy = ((y / camH) * screenCamH) + borderPixelsH;
	return(fx,fy);
}
findBoxCoordinates: topLeft, bottomRight
{
	if(startPointPix && endPointPix)
	{
		screenCamPointX = topLeft.x - borderPixelsW;
		screenCamPointY = topLeft.y - borderPixelsH;
		screenCamPointX_end = bottomRight.x - borderPixelsW;
		screenCamPointY_end = bottomRight.y - borderPixelsH;
		if(screenCamPointX < 0)
			screenCamPointX = 0;
		if(screenCamPointY < 0)
			screenCamPointY = 0;
		
		
		finalX = abs((screenCamPointX / screenCamW) * camW);
		finalY = abs((screenCamPointY / screenCamH) * camH);
		finalW = abs(((screenCamPointX_end / screenCamW) * camW) - finalX);
		finalH = abs(((screenCamPointY_end / screenCamH) * camH) - finalY);
		
		return(finalX,finalY,finalW,finalH);
	}
	else
		return(nil,nil,nil,nil);
}

toolup: te
{	
	if(endPoint)
		endPointPix = Scene().viewportProject(te.viewNumber, endPoint);
	else
		return;
	
	
	leftUp = <min(startPointPix.x,endPointPix.x),min(startPointPix.y,endPointPix.y),1>;
	rightDown = <max(startPointPix.x,endPointPix.x),max(startPointPix.y,endPointPix.y),1>;
	
	(finalX,finalY,finalW,finalH) = findBoxCoordinates(leftUp,rightDown);
	if(finalX == nil)
		return;

	if(RMB && rmbFunc == 2)
	{
		offset = endPointPix - startPointPix;
		lrX = Scene().limitedregion[1] + offset.x;
		lrY = Scene().limitedregion[2] + offset.y;
		lrW = Scene().limitedregion[3] - lrX + offset.x;
		lrH = Scene().limitedregion[4] - lrY + offset.y;
		cmd = string("RegionPosition ",integer(lrX)," ",integer(lrY )," ",integer(lrW)," ",integer(lrH));

	}                           
	else
		cmd = string("RegionPosition ",integer(finalX)," ",integer(finalY)," ",integer(finalW)," ",integer(finalH));
	

	if((finalW > 10 && finalH > 10) || (RMB && rmbFunc == 2))
	{
		limitedregion = Scene().renderopts[8];
		if(limitedregion == false)
			CommandInput("LimitedRegion 2");
		
		CommandInput("ResolutionMultiplier 1");
		cmdstr = string("FrameSize ",camW," ",camH);
		CommandInput(cmdstr);
		CommandInput(cmd);
		if(RMB && rmbFunc == 1)
			CommandInput("RenderFrame");
	}
	else
		warn("Render region smaller than 10 pixels.");
	
	
	
	
	endPoint = nil;
	startPoint = nil;
	
}

tooldirty
{

	return 1;
}


toolmove: te
{
	if(startPoint == nil)
		return;
	if(renderCamPos == nil)
	{
		renderCamPos = Scene().renderCamera(Scene().currenttime).getWorldPosition(Scene().currenttime);
	}
	endPoint = <te.posRaw[1],te.posRaw[2],te.posRaw[3]>;
	endPointPix = Scene().viewportProject(te.viewNumber, endPoint);
	
	
	//~ screenCamH
	//~ info(startPointPix.y);
	if(RMB && rmbFunc == 2)
	{
		startPointPix = Scene().viewportProject(global_teViewNumber, startPoint);
		endPointPix = Scene().viewportProject(global_teViewNumber, endPoint);
		offset = endPointPix - startPointPix;
		
		(lx,ly) = convertToScreenCam(Scene().limitedregion[1] + offset.x,Scene().limitedregion[2] + offset.y);
		(lx1,ly1) = convertToScreenCam(Scene().limitedregion[3] + offset.x,Scene().limitedregion[4] + offset.y);

		
		
		leftUp = <lx, ly ,1>;
		rightUp = <lx1, ly ,1>;
		leftDown = <lx, ly1,1>;
		rightDown = <lx1, ly1,1>;
		
		leftUpVec = Scene().viewportUnProject(global_teViewNumber, leftUp);
		rightUpVec = Scene().viewportUnProject(global_teViewNumber, rightUp);
		leftDownVec = Scene().viewportUnProject(global_teViewNumber, leftDown);
		rightDownVec = Scene().viewportUnProject(global_teViewNumber, rightDown);
		
		leftUpVec = ((leftUpVec - renderCamPos) / distMultiplier) + renderCamPos;
		rightUpVec = ((rightUpVec - renderCamPos) / distMultiplier) + renderCamPos;
		leftDownVec = ((leftDownVec - renderCamPos) / distMultiplier) + renderCamPos;
		rightDownVec = ((rightDownVec - renderCamPos) / distMultiplier) + renderCamPos;
		(global_finalX,global_finalY,global_finalW,global_finalH) = findBoxCoordinates(leftUp,rightDown);

	}
	else
	{
		leftUp = <min(startPointPix.x,endPointPix.x),min(startPointPix.y,endPointPix.y),1>;
		rightUp = <max(startPointPix.x,endPointPix.x),leftUp.y,1>;
		leftDown = <leftUp.x,max(startPointPix.y,endPointPix.y),1>;
		rightDown = <max(startPointPix.x,endPointPix.x),max(startPointPix.y,endPointPix.y),1>;

		leftUpVec = Scene().viewportUnProject(te.viewNumber, leftUp);
		rightUpVec = Scene().viewportUnProject(te.viewNumber, rightUp);
		leftDownVec = Scene().viewportUnProject(te.viewNumber, leftDown);
		rightDownVec = Scene().viewportUnProject(te.viewNumber, rightDown);
		
		leftUpVec = ((leftUpVec - renderCamPos) / distMultiplier) + renderCamPos;
		rightUpVec = ((rightUpVec - renderCamPos) / distMultiplier) + renderCamPos;
		leftDownVec = ((leftDownVec - renderCamPos) / distMultiplier) + renderCamPos;
		rightDownVec = ((rightDownVec - renderCamPos) / distMultiplier) + renderCamPos;
		
		
		(global_finalX,global_finalY,global_finalW,global_finalH) = findBoxCoordinates(leftUp,rightDown);
	}
}
options
{
	if(reqisopen() == false)
	{
		rmbFunc = integer(recall("rmbFunc",1));
		reqbegin("Limited Region Tool");
		c1 = ctlpopup("RMB",rmbFunc,@"Renders Region","Repositions Region"@);
		ctlposition(c1,2,2);
		ctlrefresh(c1,"refresh_rmbFunc");
		reqopen();
	}

}
refresh_rmbFunc: val
{
	rmbFunc = val;
	store("rmbFunc",rmbFunc);
	reqabort();
	CommandInput("Generic_DummyScriptGN");
}
toolevent: te
{
	
	//~ if(te == 2)
	//~ {
		//~ rmbFunc = integer(recall("rmbFunc",1));
		//~ options();
	//~ }
	//~ if(te == 0)
	//~ {
		//~ if(reqisopen())
		//~ {
			//~ rmbFunc = getvalue(c1);
			//~ store("rmbFunc",rmbFunc);
		//~ }
	//~ }
}
mouseLoc;
firstMouseLoc;
tooldown: te
{
	if(reqisopen())
	{
		rmbFunc = getvalue(c1);
		store("rmbFunc",rmbFunc);
	}
	(h,m,s,t) = time();
	if(tickdown)
		firsttick = tickdown;
	else
		firsttick = t;
	tickdown = t;
	if((tickdown - firsttick) <= 1)
		doubleclick = true;
	else
		doubleclick = false;
	
	if(mouseLoc)
		firstMouseLoc = mouseLoc;
	mouseLoc = <te.posRaw[1],te.posRaw[2],te.posRaw[3]>;
	
	if(mouseLoc == firstMouseLoc)
		samePlace = true;
	else
		samePlace = false;
	
		//~ info(mouseLoc," ",firstMouseLoc);
	if(doubleclick == true && samePlace == true)
	{
		options();
		return;
	}
	global_teViewNumber = te.viewNumber;
	
	//~ info(te.flags[1]);
	RMB = (te.flags[1] == 8);
	(left,right,width,height) = Scene().viewportRect(te.viewNumber);
	(camW,camH) = Scene().renderCamera(Scene().currenttime).resolution();
	camResRatio = camW / camH;
	screenRatio = width / height;	
	
	if(Scene().viewportType(te.viewNumber) != 9) // if not a camera view
	{
		// then make a camera into the current position first
		
		pos = Scene().viewportPos(te.viewNumber);
		
		xform = Scene().viewportXFrm(te.viewNumber);
		AddNull("____TEMPTARGET____");
		temptarget = Scene().firstSelect();
		centerpixel = Scene().viewportUnProject(te.viewNumber,<(((width - left) - left)/2)+left,height/2,.8>);
		Position(centerpixel);
		//~ RefreshNow();
		toppixel = Scene().viewportUnProject(te.viewNumber,<(((width - left) - left)/2)+left,0,.8>);
		AddNull("____TEMPPOLE____");
		temppole = Scene().firstSelect();
		Position(toppixel);
		//~ RefreshNow();
		
		pviewcam = addPViewCamera();
		CameraView();
		Position(pos);

		
		TargetItem(temptarget.id);
		HController(2);
		PController(2);
		PoleItem(temppole.id);
		BController(6);
		
		rot = pviewcam.getRotation(Scene().currenttime);
		Rotation(rot);
		HController(1);
		PController(1);
		BController(1);
		
		
		SelectItem(temptarget.id);
		AddToSelection(temppole.id);
		AutoConfirm(1);
		ClearSelected();
		AutoConfirm(0);
		// make a 
		//~ info(normalize(xform[1]));
		//~ info(normalize(xform[2]));
		//~ info(normalize(xform[3]));
		
		//~ info(vec_HPB(xform));
		//~ info(vec_HPB2(xform));
		//~ Rotation(vec_HPB(xform));
		//~ Rotation(vec_HPB2(xform));
		//~ Rotation(vec_hp(xform[3]));
		//~ info(xform);
	}
	
	if(screenRatio > camResRatio) // means that screen is more horizontal
	{
		screenCamH = height;
		screenCamW = height * camResRatio;
		borderPixelsW = (width - screenCamW) / 2;
		borderPixelsH = 0;
	}
	else
	{
		screenCamH = width / camResRatio;
		screenCamW = width;
		borderPixelsW = 0;
		borderPixelsH = (height - screenCamH) / 2;
		
	}
	
	gridSize = Scene().viewportGridSize(te.viewNumber);
	//~ distMultiplier = gridSize * 100000;
	//~ if(distMultiplier > 9000)
		distMultiplier = 9000;
	renderCamPos = Scene().renderCamera(Scene().currenttime).getWorldPosition(Scene().currenttime);
	startPoint = <te.posRaw[1],te.posRaw[2],te.posRaw[3]>;
	if(startPoint)
		startPointPix = Scene().viewportProject(te.viewNumber, startPoint);

	return(true);
	
}


addPViewCamera
{
	
	cam = Camera("PVRC");
	if(!cam)
	{
		AddCamera("PVRC");
		cam = Scene().firstSelect();
	}
	SelectItem(cam.id);
	ZoomFactor(4);
	return(cam);
	
}

